*Datadict.cc  Data-Dictionary management Object
*             This object enables reindexing, interactive alteration
*             of tag keys
*
*             Requires: Dict.dbf - a table with all .dbfs in a 
*                      program, their tags and keys
*             Requires: _app.path  Path to Server Tables if data i
*                   
*             Warning:: This object issues a Close Data, which
*                       requires all forms to be closed
*                       that have datalinks!!!

Class Dict

PROCEDURE Open
Param fWfm,cClass,fQbe 
Close Data

This.oMainForm = New DictForm()
This.oMainForm.MDI = .f.
This.oMainForm.ReadModal()

If type('fQbe') = 'C'     &&Reopen tables via QBE name
   Do &fQbe.
Endif
If type('fWfm') = 'C' .and. type('cClass') = 'C'
   _app.aForms.Open(fWfm,cClass) &&Reopen current form
Endif
Endclass


*----------------------------------MAIN FORM-----------------------
**Class DictForm
CLASS DICTFORM OF FORM
   this.Text = "Table Maintenance"
   this.Height = 17.2
   this.Left = 11.3
   this.Top = 0
   this.View = _app.path+'Dict'
   this.Width = 76.333
   this.OnClose = CLASS::FORM_OnClose
   this.RefreshAlways = .f.

   DEFINE RECTANGLE RECTANGLE1 OF THIS;
       PROPERTY; 
         Text "",;
         BorderStyle 1,;
         Height 12.0596,;
         Left 3.332,;
         Top 1.7637,;
         Width 69.667

   DEFINE TEXT TITLE OF THIS;
       PROPERTY; 
         Text "Data Dictionary",;
         Height 1.1777,;
         FontSize 12,;
         Left 3.332,;
         FontItalic .T.,;
         Top 0.4102,;
         Width 29.667,;
         ColorNormal "R/W"

   DEFINE BROWSE TABLEBROWSE OF THIS;
       PROPERTY; 
         CUATab .T.,;
         Append .F.,;
         Alias "DICT",;
         Fields 'DICT->DBFNAME\H="Table",DICT->LOCATION\H="Drive",DICT->USEDFOR\H="Used For"',;
         Delete .F.,;
         Modify .F.,;
         Height 9.1768,;
         ShowDeleted .F.,;
         Left 5.332,;
         ShowRecNo .F.,;
         FontBold .T.,;
         Top 2.7051,;
         Width 65.5,;
         ColorNormal "N/W"
         
    DEFINE PUSHBUTTON KEYSBUTTON OF THIS;
       PROPERTY; 
         Group .T.,;
         Text "&Keys",;
         Height 1.1182,;
         Left 59.665,;
         Top 12.2344,;
         Width 11.167,;
         SpeedTip 'View/Modify Index Keys',;
         ColorNormal "B/W"

   DEFINE PUSHBUTTON REINDEXBUTTON OF THIS;
       PROPERTY; 
         Group .T.,;
         Text "&Reindex",;
         OnClick CLASS::REINDEXBUTTON_ONCLICK,;
         Height 1.1182,;
         Left 3.332,;
         Top 14.3516,;
         SpeedTip 'Recreate Index - Selected Table',;
         Width 19.667,;
         ColorNormal "B/W"
         
    DEFINE PUSHBUTTON REINDEXALLBUTTON OF THIS;
       PROPERTY; 
         Group .T.,;
         Text "Reindex &All",;
         OnClick CLASS::REINDEXALLBUTTON_ONCLICK,;
         Height 1.1182,;
         Left 25.665,;
         Top 14.3516,;
         Speedtip 'Recreate Indexes - All Tables',;
         Width 19.667,;
         ColorNormal "B/W"

    DEFINE PUSHBUTTON PACKBUTTON OF THIS;
       PROPERTY; 
         Group .T.,;
         Text "Pac&k",;
         OnClick CLASS::PACKBUTTON_ONCLICK,;
         Height 1.1182,;
         Left 3.332,;
         Speedtip 'Remove Deletes - Selected Table',;
         Top 15.7,;
         Width 19.667,;
         ColorNormal "B/W"
         
    DEFINE PUSHBUTTON PACKALLBUTTON OF THIS;
       PROPERTY; 
         Group .T.,;
         Text "&Pack All",;
         OnClick CLASS::PACKALLBUTTON_ONCLICK,;
         Height 1.1182,;
         Speedtip 'Remove Deletes - All Tables',;
         Left 25.665,;
         Top 15.7,;
         Width 19.667,;
         ColorNormal "B/W"
  
   DEFINE PUSHBUTTON CLOSEBUTTON OF THIS;
       PROPERTY; 
         Group .T.,;
         Text "&Close",;
         OnClick CLASS::CLOSEBUTTON_ONCLICK,;
         SpeedTip 'Close Window',;
         Height 1.1182,;
         Left 59.665,;
         Top 15.7,;
         Width 11.167,;
         ColorNormal "N/W"
         
   
   PROCEDURE CLOSEBUTTON_OnClick
   Form.Close()
   
   PROCEDURE REINDEXBUTTON_OnClick
   Form.oChild = New IndexForm()
   Form.oChild.Process = "Reindex Table"
   Form.oChild.MDI = .f.
   Form.oChild.ReadModal()
   Form.oChild.Release()

   PROCEDURE REINDEXALLBUTTON_OnClick
   Form.oChild = New IndexForm()
   Form.oChild.Process = 'Reindex All'
   Form.oChild.MDI = .f.
   Form.oChild.ReadModal()
   Form.oChild.Release()
   
   PROCEDURE PACKBUTTON_OnClick
   Form.oChild = New PackForm()
   Form.oChild.Process = "Pack Table"
   Form.oChild.MDI = .f.
   Form.oChild.ReadModal()
   Form.oChild.Release()

   PROCEDURE PACKALLBUTTON_OnClick
   Form.oChild = New PackForm()
   Form.oChild.Process = 'Pack All'
   Form.oChild.MDI = .f.
   Form.oChild.ReadModal()
   Form.oChild.Release()
   
   PROCEDURE FORM_OnClose
   If Select('Dict') > 0
      Sele Dict
      Use
   Endif

ENDCLASS

*---------------------------REINDEX FORM---------------------------
**Dict.dbf must be open
**It must be sitting on the right record if process
**is NOT Reindex All
**Calling PROCEDURE must set value of Form.Process
**Form.Process = "Reindex Table '
**             or"Reindex All'
CLASS INDEXFORM OF FORM
   this.OnOpen = CLASS::FORM_ONOPEN
   this.Text = "Form"
   this.Height = 9.4111
   this.Left = 27
   this.text = 'Rebuild Indexes'
   this.Top = 2.7051
   this.Width = 60
   this.RefreshAlways = .f.

   DEFINE RECTANGLE RECTANGLE1 OF THIS;
       PROPERTY; 
         Text "",;
         BorderStyle 1,;
         Height 6.2949,;
         Left 1.5,;
         Top 0.8223,;
         Width 56.6641

 
   DEFINE TEXT CREATEDELETETEXT OF THIS;
       PROPERTY; 
         Text "        Tag",;
         Height 0.7656,;
         Left 11,;
         Top 4.7637,;
         Width 14.6641

   DEFINE TEXT REINDEXINGTABLETEXT OF THIS;
       PROPERTY; 
         Text "Reindexing Table ",;
         Height 1.4121,;
         FontSize 12,;
         Left 6.833,;
         FontItalic .T.,;
         Top 1.5879,;
         Width 47.833,;
         ColorNormal "B/W"

   DEFINE PUSHBUTTON REINDEXBUTTON OF THIS;
       PROPERTY; 
         Group .T.,;
         Text "&OK",;
         OnClick CLASS::REINDEXBUTTON_ONCLICK,;
         Speedtip 'Start Reindex',;
         Height 1.1172,;
         Left 25.832,;
         Top 7.5879,;
         Width 14.167,;
         ColorNormal "B/W"

   DEFINE PUSHBUTTON CLOSEBUTTON OF THIS;
       PROPERTY; 
         Group .T.,;
         Text "&Cancel",;
         OnClick CLASS::CLOSEBUTTON_ONCLICK,;
         SpeedTip 'Close Window',;
         Height 1.1172,;
         Left 44,;
         Top 7.5879,;
         Width 14.165,;
         ColorNormal "B/W"
         
     DEFINE ENTRYFIELD TAGFIELD OF THIS;
       PROPERTY; 
         Value "            ",;
         Height 1,;
         Left 25.8311,;
         When {;Return .f.},;
         Tabstop .f.,;
         Top 4.6465,;
         Width 21.8311,;
         ColorNormal "R/W"


   DEFINE TEXT USEDFORTEXT OF THIS;
       PROPERTY; 
         Text "                                                  ",;
         Height 0.7646,;
         Left 7.5,;
         Top 3,;
         Width 33.833

   PROCEDURE Form_OnOpen
   if Type('Form.Process') # 'C' &&this is just for testing purposes
      Form.Process = 'Reindex Table '+dict->dbfname+'.dbf'
   Endif
   
   
   if Form.Process = 'Reindex All'  &&Display titles
      Form.ReindexingTableText.text = 'Reindex All Tables'
   else
      Form.ReindexingTableText.text = 'Reindex Table '+;
      trim(dict->dbfname)+'.dbf'
      Form.UsedForText.Text = 'Used for '+dict->usedfor
   endif
   
   *******************************
   
   PROCEDURE ReindexButton_OnClick
   This.Enabled = .f.
   Form.CloseButton.Enabled = .f.
   
   If Form.Process = 'Reindex All'
      Sele Dict
      Go Top
      Do while .not. eof()
         If len(trim(dict->tag1)) > 0 &&If first tag exists
            Class::RunIndex()
         Endif
         Sele Dict
         skip
      Enddo
   else    &&if process = just index
      CLASS::RunIndex()
   endif
   Form.Close()
   
   
   ******************
   
   PROCEDURE RunIndex  &&Assumes the correct record in Dict is
                       &&Already selected
 
   Form.ReindexingTableText.text = 'Reindex Table '+;
      trim(dict->dbfname)+'.dbf'     &&Update display  
   Form.UsedForText.Text = 'Used for '+dict->usedfor
   
   Use (iif(upper(dict->Location) = 'SERVER',_app.Path,'');
      +trim(dict->DbfName)) in select() Exclusive alias IndFile &&Use file
   
      if error() # 0
         return
      endif
      
      Sele IndFile                    &&Select table to be indexed
   
   do while tagcount() > 0   &&Delete existing tags
   
      form.Createdeletetext.text = 'Deleting tag '
      form.tagfield.value = upper(Tag(1))
      
      dele tag (tag(1))
   enddo
   
   for n = 1 to 9                    &&Create replacement tags  
   
      cN = str(n,1)
      cTag = dict->Tag&cN.           &&Tagname from Dict Table
      cKey = dict->Key&cN.           &&Index key from Dict Table
      lDescend = dict->Descend&cN
      
      if len(trim(cTag)) > 0 .and. len(trim(cKey)) > 0
         Form.CreateDeleteText.Text = "Creating tag"
         Form.Tagfield.value = upper(cTag)
         Set Safety Off

         If lDescend
            Index on &cKey. tag &cTag. Descending &&Create new tag
         else
            Index on &cKey. tag &cTag.  
         endif
         
         Set Safety On
      endif
      
   EndFor
   
   Sele IndFile                      &&Close file that was just
   Use                               &&Indexed
   
   PROCEDURE CLOSEBUTTON_OnClick
   Form.Close()
   
ENDCLASS

*-----------------------------PACK FORM--------------------------------

CLASS PackForm OF FORM
   this.OnOpen = CLASS::FORM_ONOPEN
   this.Text = "Remove Deleted Records"
   this.Height = 9.4111
   this.Left = 27
   this.Top = 2.7051
   this.Width = 60

   DEFINE RECTANGLE RECTANGLE1 OF THIS;
       PROPERTY; 
         Text "",;
         Height 6.2939,;
         Left 1.166,;
         Top 0.5879,;
         Width 56.667,;
         BorderStyle 1

   DEFINE TEXT PACKINGTABLETEXT OF THIS;
       PROPERTY; 
         ColorNormal "B/W",;
         FontSize 12,;
         Text "Packing Table",;
         FontItalic .T.,;
         Height 1.4121,;
         Left 4.666,;
         Top 1.7051,;
         Width 51

   DEFINE TEXT USEDFORTEXT OF THIS;
       PROPERTY; 
         Text "                             ",;
         Height 1,;
         Left 5.666,;
         Top 3.5879,;
         Width 48

   DEFINE PUSHBUTTON PACKBUTTON OF THIS;
       PROPERTY; 
         ColorNormal "B/W",;
         Text "&Pack",;
         Group .T.,;
         OnClick CLASS::PACKBUTTON_ONCLICK,;
         SpeedTip 'Start Removing Deleted Records',;
         Height 1.1172,;
         Left 25.8311,;
         Top 7.5879,;
         Width 14.167

   DEFINE PUSHBUTTON CLOSEBUTTON OF THIS;
       PROPERTY; 
         ColorNormal "B/W",;
         Text "&Close",;
         Group .T.,;
         OnClick CLASS::CLOSEBUTTON_ONCLICK,;
         SpeedTip 'Close Window',;
         Height 1.1172,;
         Left 44,;
         Top 7.5879,;
         Width 14.1641

   PROCEDURE Form_OnOpen
   if Type('Form.Process') # 'C' &&this is just for testing purposes
      Form.Process = 'Pack Table '+dict->dbfname+'.dbf'
   Endif
   
   
   if Form.Process = 'Pack All'  &&Display titles
      Form.PACKingTableText.text = 'Pack All Tables'
   else
      Form.PACKingTableText.text = 'Pack Table '+;
      trim(dict->dbfname)+'.dbf'
      Form.UsedForText.Text = 'Used for '+dict->usedfor
   endif
   
   *******************************
   
   PROCEDURE PackButton_OnClick
   This.Enabled = .f.
   Form.CloseButton.Enabled = .f.
   
   If Form.Process = 'Pack All'
      Sele Dict
      Go Top
      Do while .not. eof()
         Class::RunPack()
         Sele Dict
         skip
      Enddo
   else    &&if process = just index
      CLASS::RunPack()
   endif
   Form.Close()
   
   
   ******************
   
   PROCEDURE RunPack  &&Assumes the correct record in Dict is
                       &&Already selected
   
   Form.PackingTableText.text = 'Pack Table '+;
      trim(dict->dbfname)+'.dbf'     &&Update display  
   
   Form.UsedForText.Text = 'Used for '+dict->usedfor
   
   Use (iif(upper(dict->Location) = 'SERVER',_app.Path,'');
      +trim(dict->DbfName)) in select() Exclusive alias IndFile &&Use file
   
      if error() # 0
         return
      endif
      
      Sele IndFile                    &&Select table to be indexed
      Pack 
   
   
   Sele IndFile                      &&Close file that was just
   Use                               &&Indexed
   
   PROCEDURE CLOSEBUTTON_OnClick
   Form.Close()
   
ENDCLASS
